package service

import (
	"errors"

    "github.com/go-admin-team/go-admin-core/sdk/service"
	"gorm.io/gorm"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
	cDto "go-admin/common/dto"
)

type LineWallet struct {
	service.Service
}

// GetPage 获取LineWallet列表
func (e *LineWallet) GetPage(c *dto.LineWalletGetPageReq, p *actions.DataPermission, list *[]models.LineWallet, count *int64) error {
	var err error
	var data models.LineWallet

	err = e.Orm.Model(&data).
		Scopes(
			cDto.MakeCondition(c.GetNeedSearch()),
			cDto.Paginate(c.GetPageSize(), c.GetPageIndex()),
			actions.Permission(data.TableName(), p),
		).
		Find(list).Limit(-1).Offset(-1).
		Count(count).Error
	if err != nil {
		e.Log.Errorf("LineWalletService GetPage error:%s \r\n", err)
		return err
	}
	return nil
}

// Get 获取LineWallet对象
func (e *LineWallet) Get(d *dto.LineWalletGetReq, p *actions.DataPermission, model *models.LineWallet) error {
	var data models.LineWallet

	err := e.Orm.Model(&data).
		Scopes(
			actions.Permission(data.TableName(), p),
		).
		First(model, d.GetId()).Error
	if err != nil && errors.Is(err, gorm.ErrRecordNotFound) {
		err = errors.New("查看对象不存在或无权查看")
		e.Log.Errorf("Service GetLineWallet error:%s \r\n", err)
		return err
	}
	if err != nil {
		e.Log.Errorf("db error:%s", err)
		return err
	}
	return nil
}

// Insert 创建LineWallet对象
func (e *LineWallet) Insert(c *dto.LineWalletInsertReq) error {
    var err error
    var data models.LineWallet
    c.Generate(&data)
	err = e.Orm.Create(&data).Error
	if err != nil {
		e.Log.Errorf("LineWalletService Insert error:%s \r\n", err)
		return err
	}
	return nil
}

// Update 修改LineWallet对象
func (e *LineWallet) Update(c *dto.LineWalletUpdateReq, p *actions.DataPermission) error {
    var err error
    var data = models.LineWallet{}
    e.Orm.Scopes(
            actions.Permission(data.TableName(), p),
        ).First(&data, c.GetId())
    c.Generate(&data)

    db := e.Orm.Save(&data)
    if err = db.Error; err != nil {
        e.Log.Errorf("LineWalletService Save error:%s \r\n", err)
        return err
    }
    if db.RowsAffected == 0 {
        return errors.New("无权更新该数据")
    }
    return nil
}

// Remove 删除LineWallet
func (e *LineWallet) Remove(d *dto.LineWalletDeleteReq, p *actions.DataPermission) error {
	var data models.LineWallet

	db := e.Orm.Model(&data).
		Scopes(
			actions.Permission(data.TableName(), p),
		).Delete(&data, d.GetId())
	if err := db.Error; err != nil {
        e.Log.Errorf("Service RemoveLineWallet error:%s \r\n", err)
        return err
    }
    if db.RowsAffected == 0 {
        return errors.New("无权删除该数据")
    }
	return nil
}
